﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Xml.Serialization;
using UnityEditor;
using UnityEngine;
using UPP.Engine;

namespace UPP.OGUI
{

    public class Test2 : Window
    {
       // [MenuItem("Unity++/Test2")]
        public static void ShowWindow()
        {
            EditorWindow.GetWindow(typeof(Test2), true, "Test2");
        }

        PropertyString prop = null;

        private void ManualCreationTest()
        {
            // Nejprve vytvorime 10 hernich trid:
            for (int i = 0; i < 10; i++)
            {
                string s = i.ToString();
                string className = "mcClass" + s;
                ClassManager.Create(
                    "MC Class " + s,              // Jmeno tridy
                    className,                    // Strojove jmeno
                    "",                           // Rodic
                    "Manual creation test #" + s, // Popis
                    false                          // Je abstraktni
                    );

                // Ka kazde teto tride dale 10 atributu:
                for (int j = 0; j < 10; j++)
                {
                    string t = j.ToString();

                    // Nejprve je potreba vytvorit serializovatelny objekt:
                    PropertyInt prop = new PropertyInt();
                    prop.ValueCount = 1;
                    prop.Name = "MC Property " + t;
                    prop.MachineName = "mcProp" + t;

                    // Nyni vytvoreni skrz manazera:
                    PropertyManager.Create(
                        prop,                   // Objekt s atributem
                        className,              // Herni trida
                        prop.GetType().FullName // Typ atributu
                        );
                }

                // Nyni vytvoreni 3 sablon ke kazde tride:
                for (int j = 0; j < 3; j++)
                {
                    string t = j.ToString();
                    string tempName = "mcTemp" + s + "_" + t;
                    TemplateManager.Create(
                        "MC Template " + s + " / " + t, // Jmeno sablony
                        tempName,                       // Strojove jmeno
                        className                       // Rodicovska trida
                        );
                }
            }
        }

        protected override void PrepareGUI()
        {
            string s = Settings.Get("test_str_prop");
            if (s == null)
            {
                prop = new PropertyString();
                prop.Name = "Testing property";
                prop.Description = "Just a testing property.";
                prop.MaxLength = 10;
            }
            else
            {
                prop = Serializer.FromString<PropertyString>(s);
            }

            Button btn = new Button("String property.");
            btn.OnClick += Btn_OnClick;

            this.OnModalReturn += Test2_OnModalReturn;

            Button mc = new Button("MC Test!");
            mc.Position = new Position(50, 50);
            mc.OnClick += Mc_OnClick;
        }

        private void Mc_OnClick(object sender)
        {
            ManualCreationTest();
        }

        private void Test2_OnModalReturn(DialogResult result, Type childType, object sender)
        {
            if (result == DialogResult.OK)
            {
                Settings.Set("test_str_prop", Serializer.ToString<PropertyString>(prop));
            }
        }

        private void Btn_OnClick(object sender)
        {
            PropertyRecord r = new PropertyRecord();
            r.PropertySerialized = prop.ToSerialized(typeof(PropertyString).FullName);

            PropertyWindow.ShowSettings(r, this);
        }

        
    }

}