﻿using UnityEngine;
using UnityEditor;
using System.Collections;
using UPP.OGUI;

public class TestWindow : EditorWindow
{
    static Panel windowCanvas;
    static Label lbl;
    static TextBox tb;
    static SplitContainer spl;

   // [MenuItem("Unity++/Test Window")]
    public static void ShowWindow()
    {
        EditorWindow.GetWindow(typeof(TestWindow));
    }

    private void PrepareGUI()
    {
        windowCanvas = new UPP.OGUI.Panel();
        windowCanvas.WindowParent = this;
        windowCanvas.Dock = UPP.DockStyle.Fill;

        SplitContainer split = new SplitContainer(SplitContainer.ModeType.Horizontal);
        split.Dock = UPP.DockStyle.Fill;
        split.Parent = windowCanvas;
        split.SetSize(50, SplitContainer.SizeType.Percentage, SplitContainer.PanelWho.First);
        split.GetPanel(SplitContainer.PanelWho.First).SizeMode = Panel.SizeModeType.ScrollBars;
        spl = split;

        Button btn = new Button("Dej test");
        btn.Position = new UPP.Position(10, 10);
        btn.Parent = split.GetPanel(SplitContainer.PanelWho.First);
        btn.OnClick += Btn_OnClick;

        Button btn2 = new Button("++");
        btn2.Position = new UPP.Position(10, 40);
        btn2.Parent = split.GetPanel(SplitContainer.PanelWho.First);
        btn2.OnClick += Btn2_OnClick;

        lbl = new Label("Unknown");
        lbl.Position = new UPP.Position(10, 10);
        lbl.BackgroundColor = Color.cyan;
        split.AddToPanel(lbl, SplitContainer.PanelWho.Second);

        tb = new TextBox();
        tb.Position = new UPP.Position(10, 40);
        split.AddToPanel(tb, SplitContainer.PanelWho.Second);
        tb.OnChange += Tb_OnChange;

        for (int i = 0; i < 20; i++)
        {
            Label l = new Label("Hello world");
            l.Position = new UPP.Position(10, 70 + (i * 30));
            split.AddToPanel(l, SplitContainer.PanelWho.First);
        }

        Table tab = new Table();
        tab.AddColumns(new string[] { "Test1", "Testing, testing", "Hello World", "Test"});
        tab.AddRow(new string[] { "1", "2", "3", "4" });
        tab.AddRow();
        tab.GetLastRow().SetValue(2, "333");
        tab.AddRow();
        tab.GetLastRow().AddValue("Added 0");
        tab.GetLastRow().AddValue("Added 1");
        tab.AddRow(new string[] { "x1", "x2", "x3", "x4" });
        for (int i = 0; i < 20; i++)
            tab.AddRow(new string[] { i + "-1", "-2", "-3", "-4" });
        tab.Size = new UPP.Size(400, 400);
        tab.Columns[0].Width = 100;
        tab.Columns[1].Width = 200;
        tab.Columns[3].Width = 200;
        tab.Position = new UPP.Position(10, 80);
        tab.Parent = split.GetPanel(SplitContainer.PanelWho.Second);
    }

    private void Tb_OnChange(object sender)
    {
        lbl.Text = tb.Value;
    }

    private void Btn2_OnClick(object sender)
    {
        UPP.Settings.Set("Test", Random.Range(0, 100).ToString());
        Debug.Log("Height: " + spl.GetPanel(SplitContainer.PanelWho.First).Size.Height);
    }

    private void Btn_OnClick(object sender)
    {
        lbl.Text = UPP.Settings.Get("Test", "neexistuje");
    }

    void OnGUI()
    { 
        if (windowCanvas == null)
            PrepareGUI();

        UPP.Region reg = new UPP.Region(0, 0, position.width, position.height);
        windowCanvas.Draw(ref reg);
    }
}