﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using UnityEditor;
using UnityEngine;
using UPP.OGUI;

namespace UPP.Engine
{
    public class TriggerEditor : Window
    {
        [MenuItem("Unity++/Trigger Editor")]
        public static void ShowWindow()
        {
            EditorWindow.GetWindow(typeof(TriggerEditor),
                Boolean.Parse(Settings.GetOrSet("UPP_windows_as_utility", true.ToString())),
                "Trigger Editor");
        }

        ComboBox sceneCombo;

        void FillCombo()
        {
            sceneCombo.Clear();
            int sceneCount = UnityEngine.SceneManagement.SceneManager.sceneCountInBuildSettings;
            for (int i = 0; i < sceneCount; i++)
            {
                string scene = System.IO.Path.GetFileNameWithoutExtension(UnityEngine.SceneManagement.SceneUtility.GetScenePathByBuildIndex(i));
                sceneCombo.Add(scene, scene);
            }
        }

        protected override void PrepareGUI()
        {
            Panel menu = new Panel();
            menu.Dock = DockStyle.Top;
            menu.Size.Height = 25;
            menu.BorderColor = ColorSchemes.BorderColorDarker;

            sceneCombo = new ComboBox("<Select Scene>");
            sceneCombo.Parent = menu;
            sceneCombo.Position = new Position(5, 2);
            FillCombo();
            sceneCombo.OnChange += SceneCombo_OnChange;

            SplitContainer spl = new SplitContainer(SplitContainer.ModeType.Horizontal, 25, SplitContainer.SizeType.Percentage, SplitContainer.PanelWho.First);
            spl.Dock = DockStyle.Fill;

            Button bAdd = new Button("Add trigger");
            bAdd.Anchor = new Anchor(true, true, false, false);
            bAdd.Position = new Position(3, 3);

            Button bEdit = new Button("Edit trigger");
            bEdit.Anchor = new Anchor(true, true, false, false);
            bEdit.Position = new Position(bAdd.Position.X + bAdd.Size.Width + 3, 3);

            Button bRemove = new Button("Remove trigger");
            bRemove.Anchor = new Anchor(true, true, false, false);
            bRemove.Position = new Position(bEdit.Position.X + bEdit.Size.Width + 3, 3);

            Panel tools = new Panel(menu);
            tools.Size = new Size(bAdd.Size.Width + bRemove.Size.Width + bEdit.Size.Width + 12, menu.Size.Height);
            tools.Dock = DockStyle.Right;
            bAdd.Parent = tools;
            bEdit.Parent = tools;
            bRemove.Parent = tools;
        }

        private void SceneCombo_OnChange(object sender)
        {
            
        }
    }
}